
% Document settings
\documentclass[11pt]{article}
\usepackage{amsmath}
\usepackage{stmaryrd}
\usepackage{bm}
\usepackage[margin=1in]{geometry}
\usepackage[pdftex]{graphicx}
\usepackage{color}
\usepackage{listings}
\usepackage{hyperref}
\usepackage{multirow}
\usepackage{multicol}
\usepackage{setspace}
\usepackage{xspace}
\usepackage{listings}

\pagestyle{plain}
\setlength\parindent{0pt}
\setlength\parskip{4pt}
\setlength{\columnseprule}{0.2pt}

% Define the speculative C++1z language.
\lstdefinelanguage{C++1z}{alsolanguage=C++,
                          escapechar=@,
                          breakatwhitespace=true,
                          breaklines=true
                          morekeywords={alignof, 
                                        decltype, 
                                        concept, 
                                        requires}}

% Default formatting for listings.
\lstset{language=C++1z,
        basicstyle=\ttfamily,
        keywordstyle=\bfseries,
        stringstyle=,
        xleftmargin=1em,
        showstringspaces=false,
        commentstyle=\rmfamily\itshape,
        columns=flexible,
        keepspaces=true,
        texcl=true}

\newcommand{\code}[1]{\lstinline @#1@}
\lstnewenvironment{codeblock}{\lstset{language=C++1z}}{}

\newcommand{\mathsc}[1]{\bm{\mathsf{#1}}}
% \newcommand{\mathsc}[1]{\mathsf{#1}}

% Types
\newcommand{\type}[1]{\ensuremath{t_{#1}}\xspace}
\newcommand{\typebool}{\ensuremath{\mathsc{bool}}\xspace}
\newcommand{\typeint}{\ensuremath{\mathsc{int}}\xspace}
\newcommand{\typefloat}{\ensuremath{\mathsc{float}}\xspace}
\newcommand{\typeref}[1]{\ensuremath{\mathsc{ref}~#1}\xspace}
\newcommand{\typefn}[2]{\ensuremath{(#1)\rightarrow #2}\xspace}

% Expressions
\newcommand{\expr}[1]{\ensuremath{e_{#1}}\xspace}
\newcommand{\exprtrue}{\ensuremath{\mathsc{true}}\xspace}
\newcommand{\exprfalse}{\ensuremath{\mathsc{false}}\xspace}
\newcommand{\exprand}[2]{\ensuremath{#1 \mathbin{\mathsc{and}} #2}\xspace}
\newcommand{\expror}[2]{\ensuremath{#1 \mathbin{\mathsc{or}} #2}\xspace}
\newcommand{\exprnot}[1]{\ensuremath{\mathsc{not}\;#1}\xspace}
\newcommand{\exprcond}[3]{\ensuremath{#1 \mathbin{?} #2 : #3}\xspace}
\newcommand{\expreq}[2]{\ensuremath{#1 = #2}\xspace}
\newcommand{\exprne}[2]{\ensuremath{#1 \neq #2}\xspace}
\newcommand{\exprlt}[2]{\ensuremath{#1 < #2}\xspace}
\newcommand{\exprgt}[2]{\ensuremath{#1 > #2}\xspace}
\newcommand{\exprle}[2]{\ensuremath{#1 \leq #2}\xspace}
\newcommand{\exprge}[2]{\ensuremath{#1 \geq #2}\xspace}
\newcommand{\expradd}[2]{\ensuremath{#1 + #2}\xspace}
\newcommand{\exprsub}[2]{\ensuremath{#1 - #2}\xspace}
\newcommand{\exprmul}[2]{\ensuremath{#1 * #2}\xspace}
\newcommand{\exprdiv}[2]{\ensuremath{#1 \mathbin{\mathsc{div}} #2}\xspace}
\newcommand{\exprrem}[2]{\ensuremath{#1 \mathbin{\mathsc{rem}} #2}\xspace}
\newcommand{\exprneg}[1]{\ensuremath{-#1}\xspace}
\newcommand{\exprrec}[1]{\ensuremath{/#1}\xspace}
\newcommand{\exprass}[2]{\ensuremath{#1 \leftarrow #2}\xspace}
\newcommand{\exprcall}[2]{\ensuremath{#1(#2)}\xspace}
\newcommand{\convval}[1]{\ensuremath{\mathsc{val}~#1}\xspace}

% Statements
\newcommand{\stmt}[1]{\ensuremath{s_{#1}}\xspace}
\newcommand{\stmtbreak}{\ensuremath{\mathsc{break}}\xspace}
\newcommand{\stmtcont}{\ensuremath{\mathsc{continue}}\xspace}
\newcommand{\stmtblock}[1]{\ensuremath{\{#1\}}\xspace}
\newcommand{\stmtwhile}[2]{\ensuremath{%
  \mathsc{while}~#1~\mathsc{do}~#2%
  }\xspace}
\newcommand{\stmtif}[3]{\ensuremath{%
  \mathsc{if}~#1~\mathsc{then}~#2~\mathsc{else}~#3%
  }\xspace}
\newcommand{\stmtret}[1]{\ensuremath{%
  \mathsc{return}~#1%
  }\xspace}
\newcommand{\stmtexpr}[1]{\ensuremath{#1}\xspace}
\newcommand{\stmtdecl}[1]{\ensuremath{#1}\xspace}
\newcommand{\stmtskip}{\ensuremath{\mathsc{skip}}\xspace}

\newcommand{\decl}[1]{\ensuremath{d_{#1}}\xspace}
\newcommand{\decllet}[4]{\ensuremath{%
  \mathsc{#1}~#2\mathbin{:}#3\mathbin{=}#4%
  }\xspace}
\newcommand{\declvar}[3]{\ensuremath{\decllet{var}{#1}{#2}{#3}}\xspace}
\newcommand{\declref}[3]{\ensuremath{\decllet{ref}{#1}{#2}{#3}}\xspace}
\newcommand{\declfn}[4]{\ensuremath{%
  \mathsc{fun}~#1(#2) \rightarrow #3~#4%
  }\xspace}

\newcommand{\terminal}[1]{\text{\code{#1}}}
\newcommand{\nonterminal}[1]{\text{\textit{#1}}}
\newcommand{\alt}[0]{\mathbin{|}}
\newcommand{\opt}{\mathrm{?}}

\title{MiniC Language Specification}

\begin{document}
\maketitle

This document describes the abstract and concrete syntax and semantics of a small C-like programming language (albeit with a very different syntax for declarations).

\input{concepts}
\input{abstract}
\input{lexical}
\input{concrete}

\end{document}



